# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ....core.datetime_utils import serialize_datetime
from .heart_rate import HeartRate
from .heart_rate_variability import HeartRateVariability
from .respiration import Respiration
from .temperature import Temperature


class SleepBiometrics(pydantic.BaseModel):
    heart_rate: typing.Optional[HeartRate]
    hrv: typing.Optional[HeartRateVariability]
    respiration: typing.Optional[Respiration]
    temperature: typing.Optional[Temperature]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
